com.fasterxml.jackson.databind.deser.std

## Class NumberDeserializers.BigDecimalDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer<BigDecimal>
      - - com.fasterxml.jackson.databind.deser.std.NumberDeserializers.BigDecimalDeserializer

All Implemented Interfaces:
  NullValueProvider, ValueInstantiator.Gettable, Serializable

Enclosing class:
  NumberDeserializers

    public static class NumberDeserializers.BigDecimalDeserializer
    extends StdScalarDeserializer<BigDecimal>

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`static NumberDeserializers.BigDecimalDeserializer` `instance`

### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_valueClass, _valueType, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

### Constructor Summary

Constructors
Constructor and Description
`BigDecimalDeserializer()`

### Method Summary

All Methods Instance Methods Concrete Methods
`BigDecimal` `deserialize(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`Object` `getEmptyValue(DeserializationContext ctxt)` Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings).
`LogicalType` `logicalType()` Method for accessing logical type of values this deserializer produces.

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer

`deserialize, deserializeWithType, getEmptyAccessPattern, getNullAccessPattern, supportsUpdate`

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_byteOverflow, _checkCoercionFail, _checkDoubleSpecialValue, _checkFloatSpecialValue, _checkFloatToIntCoercion, _checkFromStringCoercion, _checkFromStringCoercion, _checkTextualNull, _coerceBooleanFromInt, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeFromEmptyString, _deserializeFromString, _deserializeWrappedValue, _failDoubleToIntCoercion, _findCoercionFromBlankString, _findCoercionFromEmptyArray, _findCoercionFromEmptyString, _findNullProvider, _hasTextualNull, _intOverflow, _isBlank, _isEmptyOrTextualNull, _isFalse, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _isTrue, _neitherNull, _nonNullNumber, _parseBoolean, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDouble, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _reportFailedNullCoerce, _shortOverflow, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, getValueInstantiator, getValueType, getValueType, handledType, handleMissingEndArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer`

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`deserializeWithType, findBackReference, getDelegatee, getEmptyValue, getKnownPropertyNames, getNullValue, getNullValue, getObjectIdReader, isCachable, replaceDelegatee, unwrappingDeserializer`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### instance

    public static final NumberDeserializers.BigDecimalDeserializer instance

### Constructor Detail

#### BigDecimalDeserializer

    public BigDecimalDeserializer()

### Method Detail

#### getEmptyValue

    public Object getEmptyValue(DeserializationContext ctxt)

Description copied from class: `JsonDeserializer`
Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings). Usually this is same as `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` (which in turn is usually simply Java null), but it can be overridden for specific types. Or, if type should never be converted from empty String, method can also throw an exception.

This method may be called once, or multiple times, depending on what `JsonDeserializer.getEmptyAccessPattern()` returns.

Default implementation simply calls `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` and returns value.

Overrides:
  `getEmptyValue` in class `JsonDeserializer<BigDecimal>`

#### logicalType

    public final LogicalType logicalType()

Description copied from class: `JsonDeserializer`
Method for accessing logical type of values this deserializer produces. Typically used for further configuring handling of values, for example, to find which coercions are legal.

Overrides:
  `logicalType` in class `StdScalarDeserializer<BigDecimal>`
Returns:
  Logical type of values this deserializer produces, if known; `null` if not

#### deserialize

    public BigDecimal deserialize(com.fasterxml.jackson.core.JsonParser p,
                                  DeserializationContext ctxt)
                           throws IOException

Description copied from class: `JsonDeserializer`
Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

          {
              "@class": "class name",
              ...
          }

Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

           if (p.currentToken() == JsonToken.START_OBJECT) {
             p.nextToken();
           }

This results in the stream pointing to the field name, so that the two conditions align.

Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

Specified by:
  `deserialize` in class `JsonDeserializer<BigDecimal>`
Parameters:
  `p` - Parsed used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`